# $Id$
# Skeleton for Library Makefile
# Copyright 1992, The Regents of the University of Colorado

# The following symbols should be defined in order to use this skeleton:
# DIR=pathname of this directory relative to the Eli directory
# SRC=non-executable files needed during execution of Eli

SHELL	= /bin/sh

TIDY	= core a.out *~
CLEAN	= $(TIDY)

all:	$(SRC)

install:
	@for f in $(SRC); do \
		echo install -m 644 $$f $(DESTDIR)/$(DIR); \
		rm -f $(DESTDIR)/$(DIR)/$$f; \
		cp $$f $(DESTDIR)/$(DIR)/$$f; \
		chmod 644 $(DESTDIR)/$(DIR)/$$f; \
		done

executable:
	rm -rf $(TIDY) Makefile Makefile.cpp

tidy:
	rm -rf $(TIDY)

clean:
	rm -rf $(CLEAN)

# TIDY=files generated during construction not needed during execution of Eli
# CLEAN=files generated during construction needed during execution of Eli
